# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with xmlgraphics

%define section free
%define bname   spring

%define upstream_tag .RELEASE
%define upstream_version %{version}%{?upstream_tag}

Name:           spring-ws
Summary:        Spring Web Services
Version:        1.5.3
Release:        1%{?dist}
Epoch:          0
License:        ASL 2.0
Group:          Development/Libraries/Application Frameworks
URL:            http://www.springframework.org/
# svn export https://src.springframework.org/svn/spring-ws/tags/spring-ws-1.5.3
# tar czf ../SOURCES/spring-ws-1.5.3.tgz spring-ws-1.5.3/

Source0:        %{name}-%{version}.tgz
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml

Patch0:         spring-ws-pom.patch
Patch1:         spring-ws-oxm-pom.patch
Patch2:         spring-ws-security-pom.patch
Patch3:         spring-ws-oxm-tiger-pom.patch

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7
BuildRequires:  apache-commons-parent >= 0:12
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-eclipse
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  easymock
BuildRequires:  easymock2
BuildRequires:  docbkx
BuildRequires:  geronimo-genesis
BuildRequires:  jets3t
BuildRequires:  junit
BuildRequires:  mock-javamail
BuildRequires:  xmlunit
BuildRequires:  isorelax
BuildRequires:  relaxngDatatype
BuildRequires:  xsdlib
BuildRequires:  spring-build-aws-maven
BuildRequires:  sun-jaxb-1.0-impl

BuildRequires:  activemq4
BuildRequires:  acegi-security
BuildRequires:  aspectj >= 0:1.5.3
BuildRequires:  bcel
BuildRequires:  castor
BuildRequires:  derby
BuildRequires:  dom4j
BuildRequires:  ejb_2_1_api
BuildRequires:  ejb_3_0_api
BuildRequires:  hsqldb
BuildRequires:  jaf_1_1_1_api
BuildRequires:  apache-commons-dbcp
BuildRequires:  apache-commons-httpclient
BuildRequires:  apache-commons-logging
BuildRequires:  apache-taglibs-standard
BuildRequires:  jibx
BuildRequires:  glassfish-javamail141
BuildRequires:  jaxb_2_1_api
BuildRequires:  jaxb_1_0_api
BuildRequires:  jaxen
BuildRequires:  jaxws_2_1_api
BuildRequires:  jdom
BuildRequires:  jettison
BuildRequires:  jetty6
BuildRequires:  jms_1_1_api
BuildRequires:  joda-time
BuildRequires:  jpa_3_0_api
BuildRequires:  log4j
BuildRequires:  openjpa
BuildRequires:  saaj_1_3_api
BuildRequires:  servlet_2_5_api
BuildRequires:  spring-security2
BuildRequires:  spring2-aop
BuildRequires:  spring2-beans
BuildRequires:  spring2-context
BuildRequires:  spring2-core
BuildRequires:  spring2-jdbc
BuildRequires:  spring2-jms
BuildRequires:  spring2-orm
BuildRequires:  spring2-test
BuildRequires:  spring2-tx
BuildRequires:  spring2-web
BuildRequires:  spring2-webmvc
BuildRequires:  stax_1_0_api
BuildRequires:  sun-jaxb-2.1-impl
BuildRequires:  sun-saaj-1.3-impl
BuildRequires:  sun-xsom
BuildRequires:  ws-commons-axiom
BuildRequires:  ws-commons-XmlSchema
BuildRequires:  wsdl4j
BuildRequires:  wss4j
BuildRequires:  wstx
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  xmlbeans
BuildRequires:  xml-security
BuildRequires:  xom
BuildRequires:  xpp3
BuildRequires:  xstream
BuildRequires:  xws-security

Requires:       java >= 0:1.6.0
Requires:       java-fonts

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Spring Web Services is a product of the Spring community 
focused on creating document-driven Web services. Spring 
Web Services aims to facilitate contract-first SOAP 
service development, allowing for the creation of 
flexible web services using one of the many ways to 
manipulate XML payloads. 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation
Requires:       %{name}-javadoc = %{epoch}:%{version}-%{release}

%description manual
%{summary}.

%package devel
Summary:        Source jars for %{name}
Group:          Development/Java

%description devel
%{summary}.

%prep
%setup -q 

chmod -R go=u-w *

%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3

cp -p %{SOURCE1} settings.xml
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" settings.xml


%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p ${MAVEN_REPO_LOCAL}

export MAVEN_SETTINGS=$(pwd)/settings.xml
export MAVEN_OPTS="-Xmx256m -XX:MaxPermSize=128m"

%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Dmaven.test.skip=true \
        -Dmaven.test.failure.ignore=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        install

%{_bindir}/mvn-jpp \
        -e \
        -s ${MAVEN_SETTINGS} \
        -Daggregate=true \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}-sources

install -m 644 archetype/target/spring-ws-archetype-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/archetype-%{version}.jar
install -m 644 core/target/spring-ws-core-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 core-tiger/target/spring-ws-core-tiger-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/core-tiger-%{version}.jar
install -m 644 oxm/target/spring-oxm-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/oxm-%{version}.jar
install -m 644 oxm-tiger/target/spring-oxm-tiger-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/oxm-tiger-%{version}.jar
install -m 644 security/target/spring-ws-security-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/security-%{version}.jar
install -m 644 support/target/spring-ws-support-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/support-%{version}.jar
install -m 644 xml/target/spring-xml-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/xml-%{version}.jar
install -m 644 target/spring-ws-%{version}.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 target/spring-ws-%{version}-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}-sources && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

%add_to_maven_depmap org.springframework.ws spring-ws-archetype %{version} JPP/%{name} archetype
%add_to_maven_depmap org.springframework.ws spring-ws-core %{version} JPP/%{name} core
%add_to_maven_depmap org.springframework.ws spring-ws-core-tiger %{version} JPP/%{name} core-tiger
%add_to_maven_depmap org.springframework.ws spring-ws-oxm %{version} JPP/%{name} oxm
%add_to_maven_depmap org.springframework.ws spring-ws-oxm-tiger %{version} JPP/%{name} oxm-tiger
%add_to_maven_depmap org.springframework.ws spring-ws-security %{version} JPP/%{name} security
%add_to_maven_depmap org.springframework.ws spring-ws-support %{version} JPP/%{name} support
%add_to_maven_depmap org.springframework.ws spring-ws-xml %{version} JPP/%{name} xml
%add_to_maven_depmap org.springframework.ws spring-ws-parent %{version} JPP/%{name} parent
%add_to_maven_depmap org.springframework.ws spring-ws %{version} JPP %{name}

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 archetype/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-archetype.pom
install -m 644 core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-core.pom
install -m 644 core-tiger/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-core-tiger.pom
install -m 644 oxm/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-oxm.pom
install -m 644 oxm-tiger/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-oxm-tiger.pom
install -m 644 parent/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-parent.pom
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
install -m 644 security/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-security.pom
install -m 644 support/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-support.pom
install -m 644 xml/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-xml.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}


%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_javadir}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files devel
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}-sources
%{_javadir}/%{name}-sources/*.jar

%changelog
* Fri Jul 01 2011 Ralph Apel <r.apel@r-apel.de> 0:1.5.3-1
- First release

